<?php
# Copyright 2004 Todd Palino
#
# This file is part of phpMyRecipes.
#
# phpMyRecipes is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# phpMyRecipes is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# phpMyRecipes; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA


##############################################################################
# CONFIGURATION

# These are all the configuration variables for the software.  At the very
# least, you must make sure that the DB_* definitions are pointing to the
# right place.

# The DB_HOST variable is set to the hostname of the database server.  If it
# is the same as the host that the web server is on, set it to "localhost".
define("DB_HOST", "localhost");

# Username and password for the database user that the software uses.  This
# user should have full privileges to the recipes database.  MAKE SURE YOU
# CHANGE THE PASSWORD FROM THE DEFAULT.
define("DB_USER", "recipes");
define("DB_PASS", "CHANGEME");

# The name of the database.  It's suggested that you keep the default of
# "recipes", for simplicity.
define("DB_DB", "recipes");

# Set this to the name of your site.  It will be used in the title bar,
# primarily.
define("SITE_NAME", "phpMyRecipes");

# Set this to the base URL where you have installed this software.  Make sure
# that it has a "/" on the end, or many things will break.
define("URL_PREFIX", "http://localhost/recipes/");

# The number of ingredients to display per page on the Manage Ingredients page
define("INGREDIENTS_PER_PAGE", 30);

# The number of recipes to display per page on the Browse pages
define("RECIPES_PER_PAGE", 30);

# The maximum size, in bytes, of uploaded image files
define("MAX_IMAGE_SIZE", 100000);

##############################################################################
# HEADER/FOOTER TEMPLATES

# The c_header and c_footer functions define how your pages will look.
# c_header comes before the meat of the page, and should contain some sort
# of menu bar, at the least.  c_footer comes after the meat of the page, and
# doesn't need to contain much.
#
# By default, these paint a page using tables to create a menu bar down the
# side of the page, and a "framed" (not FRAMES) content area where the meat
# of the page goes.  Feel free to make any changes you want here to change
# the look and feel of the pages, but keep the function interfaces the same.

function c_header($title, $thispage) {
  global $session;
?>
<html>

<head>
<title><?php print SITE_NAME . " - $title" ?></title>
<LINK HREF="<?php print URL_PREFIX; ?>styles.css" REL="stylesheet" TYPE="text/css">
</head>

<body background="<?php print URL_PREFIX; ?>images/bgrnd76.jpg">

<P>
<TABLE WIDTH=100% BORDER=0>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE>
      <IMG WIDTH=520 HEIGHT=120 ALT="<?php print SITE_NAME; ?>" SRC="<?php print URL_PREFIX; ?>images/header.gif"></TD>
    <TD ALIGN=RIGHT VALIGN=MIDDLE>
      <IMG WIDTH=200 HEIGHT=120 ALT="'Tell me what you eat, and I will tell you what you are' - Brillat-Savarin" SRC="<?php print URL_PREFIX; ?>images/quote-bs01.gif"></TD>
  </TR>
</TABLE>
</P>

<TABLE BORDER=0 WIDTH=100%>
  <TR>
    <TD ALIGN=CENTER VALIGN=TOP WIDTH=150>
      <P><A HREF="<?php print slink(URL_PREFIX . "index.php"); ?>">
         <IMG ALT="[Home]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_home.gif" BORDER=0></A><BR>
<?php
  if (empty($session)) {
    ?><A HREF="<?php print slink(URL_PREFIX . "login.php"); ?>">
      <IMG ALT="[Login]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_login.gif" BORDER=0></A></P><?php
  } else {
    ?><A HREF="<?php print slink(URL_PREFIX . "logout.php"); ?>">
      <IMG ALT="[Logout]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_logout.gif" BORDER=0></A><BR>
      <A HREF="<?php print slink(URL_PREFIX . "profile.php"); ?>">
      <IMG ALT="[Profile]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_profile.gif" BORDER=0></A></P><?php
  }
?>

      <P><A HREF="<?php print slink(URL_PREFIX . "browse.php"); ?>">
      <IMG ALT="[Browse]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_browse.gif" BORDER=0></A><BR>
      <A HREF="<?php print slink(URL_PREFIX . "findrecipe.php"); ?>">
      <IMG ALT="[Search]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_search.gif" BORDER=0></A></P>

<?php
  if ($session{'privs'} & PRIV_ADDRECIPES) {
    ?><P><A HREF="<?php print slink(URL_PREFIX . "recipes/addrecipe.php"); ?>">
      <IMG ALT="[Add Recipe]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_add.gif" BORDER=0></A></P><?php
  }
?>

      <P><A HREF="<?php print slink(URL_PREFIX . "categories/categories.php"); ?>">
      <IMG ALT="[Manage Categories]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_categories.gif" BORDER=0>
      </A><BR>
      <A HREF="<?php print slink(URL_PREFIX . "ingredients/ingredients.php"); ?>">
      <IMG ALT="[Manage Ingredients]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_ingredients.gif" BORDER=0>
      </A><BR>
      <A HREF="<?php print slink(URL_PREFIX . "units/units.php"); ?>">
      <IMG ALT="[Manage Units]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_units.gif" BORDER=0></A><BR>
<?php
  if ($session{'privs'} & PRIV_MANAGEUSERS) {
    ?><A HREF="<?php print slink(URL_PREFIX . "users/users.php"); ?>">
      <IMG ALT="[Manage Users]" WIDTH=140 HEIGHT=35 SRC="<?php print URL_PREFIX; ?>images/b_users.gif" BORDER=0></A></P><?php
  } else {
    print "</P>\n";
  }
?>

      </TD>
    <TD WIDTH=50>&nbsp;</TD>
    <TD WIDTH=600 VALIGN=TOP ALIGN=LEFT>
<?php

  if ($thispage != "home") {
    echo "<P CLASS=\"content-header\" ALIGN=LEFT><FONT COLOR=\"#DCDCDC\">${title}</FONT></P>\n";
  }

?>
      <TABLE BORDER=2 CELLPADDING=10 BACKGROUND="<?php print URL_PREFIX; ?>images/paper002.jpg" WIDTH=90%>
        <TR><TD>
<?php
}

function c_footer() {
?>
        </TD></TR>
      </TABLE>
    </TD>
  </TR>
</TABLE>

<P>&nbsp;</P>
<P>&nbsp;</P>

<P>
<HR>
<FONT CLASS="footer">phpMyRecipes &copy;2004 Todd Palino<BR>
Don't steal anything, because it's free.</FONT></P>

</body>

</html>
<?php
}

?>
