<?php
# Copyright 2004 Todd Palino
#
# This file is part of phpMyRecipes.
#
# phpMyRecipes is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# phpMyRecipes is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# phpMyRecipes; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA

  require("include.php");

  if (($dbconn = mysql_pconnect(DB_HOST, DB_USER, DB_PASS)) <= 0) {
    dberror("dosearch.php", "Cannot connect to database");
  }
  if (! mysql_select_db(DB_DB, $dbconn)) {
    dberror("dosearch.php", "Cannot select database");
  }

  if (empty($_POST)) {
    # This should never happen
    header("Location: " . URL_PREFIX . slink("findrecipe.php"));
    exit();
  }

  $session = getsession();

  # First thing is to build the "words" search string
  $wordsstr = "";
  if (!empty($_POST{'words_all'})) {
    foreach (explode(" ", $_POST{'words_all'}) as $word) {
      $wordsstr .= "+$word ";
    }
  }
  if (!empty($_POST{'words_exact'})) {
    $wordsstr .= "\"" . $_POST{'words_exact'} . "\" ";
  }
  if (!empty($_POST{'words_any'})) {
    $wordsstr .= $_POST{'words_any'} . " ";
  }
  if (!empty($_POST{'words_without'})) {
    foreach (explode(" ", $_POST{'words_without'}) as $word) {
      $wordsstr .= "-$word ";
    }
  }
  if (!empty($_POST{'words_preformat'})) {
    $wordsstr .= $_POST{'words_preformat'};
  }

  # Format the first search criteria
  if ($wordsstr != "") {
    $wherestr = "MATCH (name,instructions) AGAINST ('$wordsstr' IN BOOLEAN MODE)";
  }
  if (!empty($_POST{'name_exact'})) {
    if (!empty($wherestr)) {
      $wherestr .= " AND name LIKE \"%" . $_POST{'name_exact'} . "%\"";
    } else {
      $wherestr = "name LIKE \"%" . $_POST{'name_exact'} . "%\"";
    }
  }

  if (count($_POST['categories']) > 0) {
  	# Categories were selected, so modify the wherestr for them
    foreach ($_POST['categories'] as $cat) {
    	if (!empty($catstr)) {
    		$catstr .= " OR category=$cat";
    	} else {
    		$catstr = "category=$cat";
    	}
    }
  	if (!empty($wherestr)) {
  		$wherestr .= " AND ($catstr)";
  	} else {
  		$wherestr = $catstr;
  	}
  }

  # Perform the search for the text stuff
  $nofirstsearch = 0;
  $subq_ids = array();
  if (!empty($wherestr)) {
    if ($results = mysql_query("SELECT id,name FROM recipes WHERE $wherestr ORDER BY name")) {
      if (mysql_num_rows($results) == 0) {
        paintpage(array());
      }

      # Get the results from the first query and make an array
      while ($row = mysql_fetch_array($results)) {
        $subq_ids[$row[1]] = $row[0];
      }

      if (count($_POST['ingids']) == 0) {
        paintpage($subq_ids);
      }
    } else {
      dberror("dosearch.php", "Cannot select recipe lines by instructions/name");
    }
  } elseif (count($_POST['ingids']) == 0) {
    # No search to do.  Empty set.
    paintpage(NULL);
  } else {
    $nofirstsearch = 1;
  }

  # Looks like we have to do an ingredients search too.
  $firsttimethrough = 1;
  $or_results = array();
  foreach ($_POST['ingids'] as $ing) {
    $search_ary = array();
    # First get the recipe lines that contain the ingredient that we're working on
    if ($results = mysql_query("SELECT id FROM recipe_ingredients WHERE ingredient=$ing")) {
      if (($_POST['ing_modifier'] == 1) && (mysql_num_rows($results) == 0)) {
        # No rows.  Result is empty set
        paintpage(array());
      }

      # Foreach ingredient line found, find the corresponding recipes
      while ($row = mysql_fetch_array($results)) {
        if ($res2 = mysql_query("SELECT id,name FROM recipes WHERE FIND_IN_SET(" . $row[0] . ", ingredients)>0")) {
          if (($_POST['ing_modifier'] == 1) && (mysql_num_rows($res2) == 0)) {
            # No rows.  Result is empty set
            paintpage(array());
          }

          # Add the recipes to our results for this ingredient
          while ($row2 = mysql_fetch_array($res2)) {
            $search_ary[$row2[1]] = $row2[0];
          }
        } else {
          dberror("dosearch.php", "Cannot select recipes by ingredient line");
        }
      }
    } else {
      dberror("dosearch.php", "Cannot select ingredient lines");
    }

    # Combine the results based on the modifier
    if ($_POST['ing_modifier'] == 1) {
      # AND the ingredients list together
      if ($firsttimethrough && $nofirstsearch) {
        # The subq set is actually a full set, not an empty set
        $subq_ids = $search_ary;
      } else {
        # Compute the straight intersection of all results
        $subq_ids = array_intersect($subq_ids, $search_ary);
      }

      # If there are no results left, short circuit the rest of the tests
      if (count($subq_ids) == 0) {
        paintpage($subq_ids);
      }
    } else {
      # OR the ingredients list together
      $or_results = array_merge($or_results, $search_ary);
    }

    $firsttimethrough = 0;
  }

  # If we were ORing ingredient lines, we need to intersect with the original search now
  if ($_POST['ing_modifier'] != 1) {
    if ($didfirstsearch) {
      $subq_ids = array_intersect($subq_ids, $or_results);
    } else {
      $subq_ids = $or_results;
    }
  }

  # Print out the page
  paintpage($subq_ids);

  function paintpage($result_set) {
    c_header("Search Results", "search");

    if (count($result_set) == 0) {
?>
<P CLASS="content"><FONT SIZE=+1>No recipes found.</FONT></P>
<?php
      c_footer();
      exit();
    }

?>
<P CLASS="content"><B>Search Results</B></P>

<TABLE WIDTH=100% BORDER=3>
  <TR>
    <TH>Recipe Name (click to view)</TH>
    <TH COLSPAN=2>Action</TH>
  </TR>
<?php

    foreach ($result_set as $name => $id) {
?>
  <TR>
    <TD ALIGN=LEFT VALIGN=MIDDLE><A HREF="<?php print slink("recipes/viewrecipe.php?r_id=$id") . "\">$name"; ?></A></TD>
<?php
      insEditRecipeField($id);
      insDelRecipeField($id);
      print "</TR>\n";
    }

?>
</TABLE>
<?php
    c_footer();
    exit();
  }

  function make_list($results) {
    $tmpary = array();
    while ($row = mysql_fetch_array($results)) {
      $tmpary[$row[1]] = $row[0];
    }
    return $tmpary;
  }
?>
