<?php
# Copyright 2004 Todd Palino
#
# This file is part of phpMyRecipes.
#
# phpMyRecipes is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# phpMyRecipes is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# phpMyRecipes; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA

  function check_perms($cwd, $uid, $gid) {
    $err = 0;

    if ($contents = opendir($cwd)) {
      while (($node = readdir($contents)) !== false) {
        if (($node != ".") && ($node != "..")) {
          $fn = $cwd . "/" . $node;

          $f_uid = fileowner($fn);
          $f_gid = filegroup($fn);
          $f_perm = fileperms($fn);
          print "$fn: Owner ($f_uid), Group ($f_gid), Permissions (" . substr(sprintf('%o', $f_perm), -4) . ") - ";

          if ($f_uid == $uid) {
            # Set the perms ourselves
            if (is_dir($fn)) {
              if (! chmod($fn, 0755)) {
                print "Cannot set permissions to 0755.<BR>\n";
                $err = 1;
              } else {
                print "OK<BR>\n";
              }
            } else {
              if (! chmod($fn, 0644)) {
                print "Cannot set permissions to 0644.<BR>\n";
                $err = 1;
              } else {
                print "OK<BR>\n";
              }
            }
          } else {
            # Owner not OK
            print "Owner is incorrect.<BR>\n";
            $err = 1;
          }

          if (is_dir($fn)) {
            if (check_perms($fn, $uid, $gid)) {
              $err = 1;
            }
          }
        }
      }
    } else {
      print "Cannot open directory ($cwd) for reading.<BR>\n";
      $err = 1;
    }

    return $err;
  }

?>
<HTML>
<HEAD>
<TITLE>phpMyRecipes Install - Step 1</TITLE>
</HEAD>

<BODY>
<P><H1><CENTER>phpMyRecipes Installation</CENTER></H1><BR>
<H2>Step 1 - File Permissions</H2></P>

<?php
  # First, get the current uid and group
  if (! touch("/tmp/phpMyRecipe.test")) {
    print "Temp directory is not writeable.  Cannot proceed.\n";
    exit(1);
  }

  $run_uid = fileowner("/tmp/phpMyRecipe.test");
  $run_gid = filegroup("/tmp/phpMyRecipe.test");
  unlink("/tmp/phpMyRecipe.test");

  print "<P>Running as user ID $run_uid<BR>\n";
  print "Running as group ID $run_gid</P>\n";
  
  # Get current directory
  $cwd = dirname(__FILE__);
  $pos = strrpos($cwd, "/install");
  if ($pos === false) {
    print "<P>Your distribution is not correct.  Please start over.</P>\n";
    exit();
  } else {
    $rootdir = substr($cwd, 0, $pos);
  }


  print "<P>Checking file ownership and permissions:<BR>\n";
  if (check_perms($rootdir, $run_uid, $run_gid)) {
?>
</P>

<P>At least some of the files and directories are owned by the wrong user,
or have the wrong permissions (and we can't set them correctly).  All of
the files and directories in the phpMyRecipes directory must be owned by
the user that the webserver runs as (i.e. "apache" or "nobody").  For this
server, the appropriate user ID is <?php print $run_uid; ?>.  Please
change the ownership of all files, including the main directory, to this
user.  One way to do this is to run the following command as the root
user on the webserver:
<BLOCKQUOTE><PRE>chown -R <?php print "$run_uid:$run_gid $rootdir"; ?></PRE></BLOCKQUOTE>
</P>

<P>When this is complete, try this again.</P>
<?php
    exit();
  }

?>
<P><H2><A HREF="step2.php">Move on to step 2</A></H2></P>

</BODY>
</HTML>
